//
// Cyrano Chess engine
//
// Copyright (C) 2007  Harald JOHNSEN
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of the
// License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA
//
//

class Stats {
public:
    Stats() {}
    void raz() {
        Hcutoff = Halpha = Hbeta = 0;
        Hcollide = Hdepthinsert = Hdepthfound = Hused = Hupdate = 0;
        Killers = reSearch = repCount = badType = 0;
        NM1 = NM2 = NM3 = 0;
        LMR = LMRreSearch = 0;
        cCUT = cCUTrank1 = cCUTrankn = 0;
        // Hsize = 0; total hash, don't reset
        FP_frontier = FP_QS = QS_count = 0;
        recapture = 0;
    }
    void report() {
//        printf("# Hcut=%d Ha=%d Hb=%d (%1.1f) FP=%d FPQS=%d rec=%d K=%d reS=%d lmr=%d lmrR=%d\n",
//            Hcutoff, Halpha, Hbeta, (100.0f*Hused) / Hsize, FP_frontier, FP_QS, recapture, Killers, reSearch, 
//            LMR, LMRreSearch);
        printf("# Hcut=%d %1.1f %1.1f lmr=%d lmrr=%d (%1.1f) FP=%d FPQS=%d rec=%d K=%d reS=%d inQS=%d\n",
            Hcutoff, (100.0f*(cCUTrank1+1)) / (cCUT+1), (100.0f*(cCUTrankn+1)) / (cCUT+1), 
            LMR, LMRreSearch, (100.0f*Hused) / Hsize, FP_frontier, FP_QS, 
            recapture, Killers, reSearch, QS_count);
    }

    int Hcutoff, Halpha, Hbeta;
    int Hcollide, Hdepthinsert, Hdepthfound, Hused, Hupdate;
    int Killers, reSearch, badType;
    int repCount;
    int cCUT, cCUTrank1, cCUTrankn;
    int NM1, NM2, NM3;
    int LMR, LMRreSearch;
    int Hsize;
    int FP_frontier, FP_QS, QS_count;
    int recapture;
};

extern Stats stats;
